import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


/**
 * Write a description of class GalagaWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GalagaWorld extends World
{

int score = 0 ; //score of game
int level = 1 ; //level player is on
int amountOfEnemies = 20 ; //amount of enemies on screen, this is for levels 1-3
int amountOfLives = 2 ; //amount of lives, may go up or down
int extraLifeScore = 5000 ;//amount of points needed to get an extra life
boolean gameOverCheck = true ;//changes false so game over displayed only once
Score ActorScore = new Score();
Level ActorLevel = new Level();
NextLevelImage nextLevelImage = new NextLevelImage();
GameOverImage gameOverImage = new GameOverImage();
Life life1 = new Life(); //always start with this life
Life life2 = new Life(); //always start with this life
Life life3 = new Life(); //gained if earned extra life
SeanConnery seanConnery = new SeanConnery() ;//the most deadly object ever
    /**
     * Constructor for objects of class GalagaWorld.
     * 
     */
    public GalagaWorld()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(50, 50, 10);
        
        for(int i = 0 ; i < 8 ; i++){ //this adds all enemies
            
        addObject(new Enemy1(), 7 + 5*i, 15) ;
        addObject(new Enemy2(), 7 + 5*i, 10) ;
        if(i % 2 == 0){
            addObject(new Enemy3(), 9 + 5*i, 5) ;
        }
    }
        addObject(new Ship(), 25, 45) ;
        
        addObject(this.life1, 1, 48);
        addObject(this.life2, 4, 48);
        
        
        // Put in your own background image by replacing "greenfoot.png" with the
        // image that should be used as background and uncommenting the line below.
        
        setBackground("space.jpg"); 
        
    }
    
    public void act(){
            drawScore();
            drawLevel();
            checkIfNextLevel();
            checkIfGameOver();
            if(score >= extraLifeScore){
                checkExtraLife();
            }
    }
    
    public void addToScore(int x){
        score = score + x ; // x may change depending on enemy
    }
    
    public void addToLevel(){
        level = level + 19 ; //level can only go up one at a time
    }
    
    
    public void drawScore(){
        addObject(this.ActorScore, 3, 1) ;
        ActorScore.getImage().clear();
        ActorScore.getImage().drawString("" + score, 20, 20) ;
    }
    
    public void drawLevel(){
        addObject(this.ActorLevel, 45, 1) ;
        ActorLevel.getImage().clear();
        ActorLevel.getImage().drawString("Level " + level, 10, 20);
    }

    public void subtractFromEnemies(){
        amountOfEnemies--;
    }
    
    public int getAmountEnemies(){
        return amountOfEnemies ;
    }
    
    public void checkIfNextLevel(){
        if(amountOfEnemies == 0 && level < 20){
            removeObjects(getObjects(Bullet.class));
            removeObjects(getObjects(Enemy_Bullet.class));
            displayNextLevel();
            addToLevel();
            repaintEnemies();
            if(level < 3){
                amountOfEnemies = 20 ;
            }
            if(level == 3 || level == 4){
                amountOfEnemies = 28 ;
            }
            if(level >= 5 && level < 10){
                amountOfEnemies = 32 ;
            }
            if(level >= 10 && level < 20){
                amountOfEnemies = 40 ;
            }
            if(level == 20){
                amountOfEnemies = 1 ;
            }
        }
    }
    
    public void checkIfGameOver(){
        if(amountOfLives < 0 && gameOverCheck == true){
            displayGameOver();
            removeObjects(getObjects(Enemy.class));
            gameOverCheck = false ;
        }
    }
    
    public void repaintEnemies(){
        if(level >= 1 && level < 20){
            for(int i = 0 ; i < 8 ; i++){
                addObject(new Enemy1(), 7 + 5*i, 15) ;
                addObject(new Enemy2(), 7 + 5*i, 10) ;
                if(level == 3 || level == 4){ //enemy amount increases after level three
                    addObject(new Enemy1(), 7 + 5*i, 20) ;
                    amountOfEnemies = 28 ;
                }
                if(level >= 5 && level < 10){
                    addObject(new Enemy1(), 7 + 5*i, 20) ;
                    if(i % 2 == 0){
                        addObject(new Enemy3(), 9 + 5*i, 2) ;
                    }
                }
                if(level >= 10){
                    addObject(new Enemy1(), 7 + 5*i, 20) ;
                    addObject(new Enemy1(), 7 + 5*i, 25) ;
                    if(i % 2 == 0){
                        addObject(new Enemy3(), 9 + 5*i, 2) ;
                    }
                }
                if(i % 2 == 0){
                    addObject(new Enemy3(), 9 + 5*i, 5) ;
                }
            }
        }
        if(level == 20){
            addObject(this.seanConnery, 25, 15) ;
            Greenfoot.playSound("seanConnerySound1.wav");
            Greenfoot.delay(350);
        }
    }
    
    public void displayNextLevel(){
        addObject(this.nextLevelImage, 25, 25);
        this.nextLevelImage.displayNextLevel();
        removeObject(this.nextLevelImage);
    }
    
    public void displayGameOver(){
        addObject(this.gameOverImage, 25, 25);
        this.gameOverImage.displayGameOver();
        removeObject(this.gameOverImage);
    }
    
    public void subtractFromLives(){
        amountOfLives--;
    }
    
    public int getAmountOfLives(){
        return amountOfLives ;
    }
    
    public void loseLife(){
        if(amountOfLives == 2){
            removeObject(this.life3);
        }
        if(amountOfLives == 1){ 
            removeObject(this.life2);
        }
        if(amountOfLives == 0){
            removeObject(this.life1);
        }
    }
    
    public void checkExtraLife(){
        if(amountOfLives < 3){
            addExtraLife();
        }
        else{
            extraLifeScore = extraLifeScore + 5000 ;
        }
    }
    
    public void addExtraLife(){
        if(amountOfLives == 2){
            addObject(this.life3, 7, 48) ;
        }
        if(amountOfLives == 1){
            addObject(this.life2, 4, 48) ;
        }
        if(amountOfLives == 0){
            addObject(this.life1, 1, 48) ;
        }
        Greenfoot.playSound("extraLifeNoise.wav");
        amountOfLives++;
        extraLifeScore = extraLifeScore + 5000;
    }
    
    public void makeNewShip(){
        removeObjects(getObjects(Enemy_Bullet.class));
        addObject(new Ship(), 25, 45) ;
    }
    
    
}
